// generated by ../deps/sqlpp11/scripts/ddl2cpp permissions.sqlpp11.sql permissions wee
#ifndef WEE_PERMISSIONS_H
#define WEE_PERMISSIONS_H

#include <sqlpp11/table.h>
#include <sqlpp11/data_types.h>
#include <sqlpp11/char_sequence.h>

namespace wee
{
  namespace Permissions_
  {
    struct Id
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "id";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T id;
            T& operator()() { return id; }
            const T& operator()() const { return id; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::must_not_insert, sqlpp::tag::must_not_update>;
    };
    struct Resource
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "resource";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T resource;
            T& operator()() { return resource; }
            const T& operator()() const { return resource; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Role
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "role";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T role;
            T& operator()() { return role; }
            const T& operator()() const { return role; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Since
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "since";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T since;
            T& operator()() { return since; }
            const T& operator()() const { return since; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::time_point>;
    };
    struct Project
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "project";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T project;
            T& operator()() { return project; }
            const T& operator()() const { return project; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Rank
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "rank";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T rank;
            T& operator()() { return rank; }
            const T& operator()() const { return rank; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Assigner
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "assigner";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T assigner;
            T& operator()() { return assigner; }
            const T& operator()() const { return assigner; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
  } // namespace Permissions_

  struct Permissions: sqlpp::table_t<Permissions,
               Permissions_::Id,
               Permissions_::Resource,
               Permissions_::Role,
               Permissions_::Since,
               Permissions_::Project,
               Permissions_::Rank,
               Permissions_::Assigner>
  {
    struct _alias_t
    {
      static constexpr const char _literal[] =  "permissions";
      using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
      template<typename T>
      struct _member_t
      {
        T permissions;
        T& operator()() { return permissions; }
        const T& operator()() const { return permissions; }
      };
    };
  };
} // namespace wee
#endif
